/// <reference types="react" />
import { DiagramEngine } from "./DiagramEngine";
import { NodeModel } from "./models/NodeModel";
import { LinkModel } from "./models/LinkModel";
/**
 * @author Dylan Vorster
 */
export declare abstract class WidgetFactory {
    type: string;
    constructor(name: string);
    getType(): string;
}
export declare abstract class NodeWidgetFactory extends WidgetFactory {
    abstract generateReactWidget(diagramEngine: DiagramEngine, node: NodeModel): JSX.Element;
}
export declare abstract class LinkWidgetFactory extends WidgetFactory {
    abstract generateReactWidget(diagramEngine: DiagramEngine, link: LinkModel): JSX.Element;
}
